// MailFrame.cpp : implementation file
//

#include "stdafx.h"
#include "psm.h"
#include "MailFrame.h"
#include "MailListView.h"
#include "MailRTFView.h"
#include "PSMDoc.h"
#include "aplTopLevelItem.h"
#include "aplMessageTreeItem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMailFrame

IMPLEMENT_DYNCREATE(CMailFrame, CFrameWnd)

CMailFrame::CMailFrame()
{
}

CMailFrame::~CMailFrame()
{
}


BEGIN_MESSAGE_MAP(CMailFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMailFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMailFrame message handlers

BOOL CMailFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	CMailListView* pView;
	pView = (CMailListView*)CreateView(pContext);
	ASSERT(pView);

	SetActiveView(pView);
	
	return TRUE;
}

int CMailFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT|TBSTYLE_LIST|TBSTYLE_WRAPABLE, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAILFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if(aplGetBitPerPixel(0)>8)
	{
		CBitmap bmp0;
		bmp0.LoadBitmap(IDB_MESSAGE_FRAME);
		m_il_ToolBar.Create(20,18,ILC_COLOR24|ILC_MASK,0,20);
		m_il_ToolBar.Add(&bmp0,RGB(192,192,192));
		m_wndToolBar.GetToolBarCtrl().SetImageList(&m_il_ToolBar);

		HIMAGELIST tmp_il1=aplImageListCopyAsSpecificBlend((HIMAGELIST)(*m_wndToolBar.GetToolBarCtrl().GetImageList()),25,true);//,RGB(255,255,255));
		m_il_mf_gray.Attach(tmp_il1);
		m_wndToolBar.GetToolBarCtrl().SetDisabledImageList(&m_il_mf_gray);

	}
	
	return 0;
}

void CMailFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

IMPLEMENT_DYNCREATE(CMailBodyFrame, CFrameWnd)

CMailBodyFrame::CMailBodyFrame()
{
}

CMailBodyFrame::~CMailBodyFrame()
{
}


BEGIN_MESSAGE_MAP(CMailBodyFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMailBodyFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMailFrame message handlers

BOOL CMailBodyFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	CMailRTFView* pView;
	pView = (CMailRTFView*)CreateView(pContext);
	ASSERT(pView);

	SetActiveView(pView);
	
	return TRUE;
}

int CMailBodyFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(!m_wndDlgBar.Create(this, IDD_MAIL_DIALOG_BAR, CBRS_TOP, IDD_MAIL_DIALOG_BAR))
	{
		TRACE0("Failed to create dialog bar\n");
		return -1;      // fail to create		
	}
	
	return 0;
}

void CMailBodyFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();	
}

LRESULT CMailBodyFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(message==((CPSMApp*)AfxGetApp())->m_view_update)
	{
		if(wParam==APL_UPDATE_TREE_ITEM)
		{
			if(lParam && ((CaplTreeItem*)lParam)->m_type==APL_TREE_ITEM_MESSAGE)
			{
				CaplMessageTreeItem* item = (CaplMessageTreeItem*)lParam;
				CMailRTFView* view= (CMailRTFView*)GetActiveView();
				if(view)
				{
					CaplInstance* mes= item->m_message;
					if(mes)
					{
						CString sFrom, sTo, sSubject;
						
						sFrom= CaplMessageTreeItem::GetMessageSend(view->GetDocument(), mes);
						sTo= CaplMessageTreeItem::GetMessageRecip(view->GetDocument(), mes);
						view->GetDocument()->m_api.m_data.GetAttr(mes, view->GetDocument()->m_api.m_message_mgr.a_message_subject, sSubject);

						view->UpdateBody(mes);
						view->m_cur_item= item;
						UpdateHeader(sFrom, sTo, sSubject);
					}
				}
			}
		}
		else if(wParam==3)
		{
			CMailRTFView* view= (CMailRTFView*)GetActiveView();
			if(view)
			{
				view->EndRead();
			}
		}
	}
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

void CMailBodyFrame::UpdateHeader(CString sFrom,  CString sTo,  CString sSubject)
{
	CEdit* pEdit= NULL;
	pEdit= (CEdit*) m_wndDlgBar.GetDlgItem(IDC_MAIL_DB_FROM_EDIT);
	if(pEdit)pEdit->SetWindowText(sFrom);
	pEdit= (CEdit*) m_wndDlgBar.GetDlgItem(IDC_MAIL_DB_TO_EDIT);
	if(pEdit)pEdit->SetWindowText(sTo);
	pEdit= (CEdit*) m_wndDlgBar.GetDlgItem(IDC_MAIL_DB_SUBJECT_EDIT);
	if(pEdit)pEdit->SetWindowText(sSubject);
}
